## net.sf.saxon.event
Class ProxyReceiver

    java.lang.Object
      |
      +--net.sf.saxon.event.ProxyReceiver

All Implemented Interfaces:
  Receiver, javax.xml.transform.Result

Direct Known Subclasses:
  CDATAFilter, CharacterMapExpander, CommentStripper, HTMLIndenter, NamePoolConverter, NamespaceReducer, PIGrabber, Stripper, TransformerReceiver, XMLIndenter

public abstract class ProxyReceiver
extends java.lang.Object
implements Receiver

A ProxyReceiver is an Receiver that filters data before passing it to another underlying Receiver.

Field Summary
`protected Receiver` `baseReceiver`
`protected Configuration` `config`
`protected LocationProvider` `locationProvider`
`protected java.lang.String` `systemId`

Fields inherited from interface javax.xml.transform.Result
`PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

Constructor Summary
`ProxyReceiver()`

Method Summary
`void` `attribute(int nameCode, int typeCode, java.lang.CharSequence value, int locationId, int properties)` Notify an attribute.
`void` `characters(java.lang.CharSequence chars, int locationId, int properties)` Character data
`void` `close()` End of document
`void` `comment(java.lang.CharSequence chars, int locationId, int properties)` Output a comment
`void` `endDocument()` Notify the end of a document node
`void` `endElement()` End of element
`Configuration` `getConfiguration()` Get the configuration
`LocationProvider` `getDocumentLocator()` Get the Document Locator
`NamePool` `getNamePool()` Get the namepool for this configuration
`java.lang.String` `getSystemId()`
`Receiver` `getUnderlyingReceiver()` Get the underlying Receiver (that is, the next one in the pipeline)
`void` `namespace(int namespaceCode, int properties)` Notify a namespace.
`void` `open()` Start of document
`void` `processingInstruction(java.lang.String target, java.lang.CharSequence data, int locationId, int properties)` Processing Instruction
`void` `setConfiguration(Configuration config)` Set the name pool to be used for all name codes
`void` `setDocumentLocator(LocationProvider locator)` Set the Document Locator
`void` `setSystemId(java.lang.String systemId)` Set the System ID of the destination tree
`void` `setUnderlyingReceiver(Receiver receiver)` Set the underlying receiver.
`void` `setUnparsedEntity(java.lang.String name, java.lang.String uri, java.lang.String publicId)` Set the URI for an unparsed entity in the document.
`void` `startContent()` Notify the start of the content, that is, the completion of all attributes and namespaces.
`void` `startDocument(int properties)` Start of a document node.
`void` `startElement(int nameCode, int typeCode, int locationId, int properties)` Notify the start of an element

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### baseReceiver

    protected Receiver baseReceiver

### config

    protected Configuration config

### systemId

    protected java.lang.String systemId

### locationProvider

    protected LocationProvider locationProvider

Constructor Detail

### ProxyReceiver

    public ProxyReceiver()

Method Detail

### setSystemId

    public void setSystemId(java.lang.String systemId)

  Description copied from interface: `Receiver`
  Set the System ID of the destination tree

  Specified by:
    `setSystemId` in interface `Receiver`

### getSystemId

    public java.lang.String getSystemId()

  Specified by:
    `getSystemId` in interface `javax.xml.transform.Result`

### setUnderlyingReceiver

    public void setUnderlyingReceiver(Receiver receiver)

  Set the underlying receiver. This call is mandatory before using the Receiver.

### getUnderlyingReceiver

    public Receiver getUnderlyingReceiver()

  Get the underlying Receiver (that is, the next one in the pipeline)

### setConfiguration

    public void setConfiguration(Configuration config)

  Set the name pool to be used for all name codes

  Specified by:
    `setConfiguration` in interface `Receiver`

### getConfiguration

    public Configuration getConfiguration()

  Description copied from interface: `Receiver`
  Get the configuration

  Specified by:
    `getConfiguration` in interface `Receiver`

### getNamePool

    public NamePool getNamePool()

  Get the namepool for this configuration

### open

    public void open()
              throws XPathException

  Start of document

  Specified by:
    `open` in interface `Receiver`
    `XPathException`

### close

    public void close()
               throws XPathException

  End of document

  Specified by:
    `close` in interface `Receiver`
    `XPathException`

### startDocument

    public void startDocument(int properties)
                       throws XPathException

  Start of a document node.

  Specified by:
    `startDocument` in interface `Receiver`
    `XPathException`

### endDocument

    public void endDocument()
                     throws XPathException

  Notify the end of a document node

  Specified by:
    `endDocument` in interface `Receiver`
    `XPathException`

### startElement

    public void startElement(int nameCode,
                             int typeCode,
                             int locationId,
                             int properties)
                      throws XPathException

  Notify the start of an element

  Specified by:
    `startElement` in interface `Receiver`
  Parameters:
    `nameCode` - integer code identifying the name of the element within the name pool.
    `typeCode` - integer code identifying the element's type within the name pool.
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `XPathException`

### namespace

    public void namespace(int namespaceCode,
                          int properties)
                   throws XPathException

  Notify a namespace. Namespaces are notified after the startElement event, and before any children for the element. The namespaces that are reported are only required to include those that are different from the parent element; however, duplicates may be reported. A namespace must not conflict with any namespaces already used for element or attribute names.

  Specified by:
    `namespace` in interface `Receiver`
  Parameters:
    `namespaceCode` - an integer: the top half is a prefix code, the bottom half a URI code. These may be translated into an actual prefix and URI using the name pool. A prefix code of zero represents the empty prefix (that is, the default namespace). A URI code of zero represents a URI of "", that is, a namespace undeclaration.
  Throws:
    `IllegalStateException:` - attempt to output a namespace when there is no open element start tag
    `XPathException`

### attribute

    public void attribute(int nameCode,
                          int typeCode,
                          java.lang.CharSequence value,
                          int locationId,
                          int properties)
                   throws XPathException

  Notify an attribute. Attributes are notified after the startElement event, and before any children. Namespaces and attributes may be intermingled.

  Specified by:
    `attribute` in interface `Receiver`
  Parameters:
    `nameCode` - The name of the attribute, as held in the name pool
    `typeCode` - The type of the attribute, as held in the name pool
    `properties` - Bit significant value. The following bits are defined:
    DISABLE_ESCAPING
  Disable escaping for this attribute
    NO_SPECIAL_CHARACTERS
  Attribute value contains no special characters
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
  Throws:
    `IllegalStateException:` - attempt to output an attribute when there is no open element start tag
    `XPathException`

### startContent

    public void startContent()
                      throws XPathException

  Notify the start of the content, that is, the completion of all attributes and namespaces. Note that the initial receiver of output from XSLT instructions will not receive this event, it has to detect it itself. Note that this event is reported for every element even if it has no attributes, no namespaces, and no content.

  Specified by:
    `startContent` in interface `Receiver`
    `XPathException`

### endElement

    public void endElement()
                    throws XPathException

  End of element

  Specified by:
    `endElement` in interface `Receiver`
    `XPathException`

### characters

    public void characters(java.lang.CharSequence chars,
                           int locationId,
                           int properties)
                    throws XPathException

  Character data

  Specified by:
    `characters` in interface `Receiver`
  Parameters:
    `chars` - The characters
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this text node
  USE_CDATA
    Output as a CDATA section
  NO_SPECIAL_CHARACTERS
    Value contains no special characters
  WHITESPACE
    Text is all whitespace
    `XPathException`

### processingInstruction

    public void processingInstruction(java.lang.String target,
                                      java.lang.CharSequence data,
                                      int locationId,
                                      int properties)
                               throws XPathException

  Processing Instruction

  Specified by:
    `processingInstruction` in interface `Receiver`
  Parameters:
    `target` - The PI name. This must be a legal name (it will not be checked).
    `data` - The data portion of the processing instruction
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the PI. The following bits are defined:
  CHECKED
    Data is known to be legal (e.g. doesn't contain "?>")
    `XPathException`

### comment

    public void comment(java.lang.CharSequence chars,
                        int locationId,
                        int properties)
                 throws XPathException

  Output a comment

  Specified by:
    `comment` in interface `Receiver`
  Parameters:
    `chars` - The content of the comment
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the comment. The following bits are defined:
  CHECKED
    Comment is known to be legal (e.g. doesn't contain "--")
    `XPathException`

### setUnparsedEntity

    public void setUnparsedEntity(java.lang.String name,
                                  java.lang.String uri,
                                  java.lang.String publicId)
                           throws XPathException

  Set the URI for an unparsed entity in the document.

  Specified by:
    `setUnparsedEntity` in interface `Receiver`
  Parameters:
    `name` - The name of the unparsed entity
    `uri` - The system identifier of the unparsed entity
    `publicId` - The public identifier of the unparsed entity
    `XPathException`

### setDocumentLocator

    public void setDocumentLocator(LocationProvider locator)

  Set the Document Locator

  Specified by:
    `setDocumentLocator` in interface `Receiver`

### getDocumentLocator

    public LocationProvider getDocumentLocator()

  Get the Document Locator

  Specified by:
    `getDocumentLocator` in interface `Receiver`